moSetGetInputOutputOther = {};

function moSetGetInputOutputOther:getOther(self, objectTable, xmlModString)	
	local inputFillTypes={}
	local outputFillTypes={}
	local container = 1;
	local ratio = 0;
	local setProduktivity = false;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local outputFull = false;
	local inputEmty = false;
	local capacity = 0;
	local fillLevel = 0;
	if objectTable ~= nil and xmlModString == nil then		
		local name = "";
		if objectTable.name ~= nil then name = string.lower(string.gsub(objectTable.name, " ", ""));end;
		local otherType = "";
		if objectTable.otherType ~= nil then otherType = string.lower(objectTable.otherType);end;
		if string.find(name, "mischstation") or name == "ruebenschneider" or otherType == "mischstation" then --Mischstation,Rübenschneider			
			setProduktivity = true;
			local info={};
			info.capacity = objectTable.LvLIndicator.capacity;	
			info.fillLevel = objectTable.MixLvl;
			ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			if tonumber(ratio) >= 100 then outputFull = true;end;
			--if tonumber(productivity) >= tonumber(ratio) then
			--	productivity = tonumber(ratio);	
			--end;
			info.container = container;
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			outputFillTypes[container] = {};
			local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, Fillable.FILLTYPE_FORAGE, info.fillTypeName, nil);					
			info.fillTypeName = fillTypeNameString;
			info.pricePerLiter = pricePerLiter;
			table.insert(outputFillTypes[container], info);
			table.remove(info);
			container = 1;
			for a=1, table.getn(objectTable.MixTypLvl) do		
				info={};
				info.capacity = objectTable.TipTriggers[a].capacity;	
				info.fillLevel = objectTable.MixTypLvl[a];
				if info.fillLevel <= 0.1 then inputEmty = true;end;
				if not outputFull then
					if not inputEmty then
						capacity = capacity+info.capacity;
						fillLevel = fillLevel+info.fillLevel;
					end;					
				end;
				info.container = container;
				info.fillTypeName = "";
				info.lengthFillTypes = 1;					
				inputFillTypes[container] = {};
				local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, objectTable.MixTypName[a].index, info.fillTypeName, nil);					
				info.fillTypeName = fillTypeNameString;
				info.pricePerLiter = pricePerLiter;
				table.insert(inputFillTypes[container], info);
				container = container+1;
			end;
			table.remove(info);			
		elseif name == "seedmaster2k15" or name == "beetmaster100k" or name == "kompostier_anlage" or otherType == "fermentingsilo" then --SeedMaster2k15,BeetMaster100K,Kompostier_Anlage
			setProduktivity = true;
			local info={};
			info.capacity = objectTable.TipTrigger.capacity;	
			info.fillLevel = objectTable.SilageLvl;
			ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			if tonumber(ratio) >= 100 then outputFull = true;end;
			--if tonumber(productivity) >= tonumber(ratio) then
			--	productivity = tonumber(ratio);	
			--end;
			info.container = container;
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			outputFillTypes[container] = {};
			local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, objectTable.SilageTrigger.fillType, info.fillTypeName, objectTable.L_Silage);					
			info.fillTypeName = fillTypeNameString;
			info.pricePerLiter = pricePerLiter;
			table.insert(outputFillTypes[container], info);			
			table.remove(info);
			container = 1;
			info={};
			info.capacity = objectTable.TipTrigger.capacity;
			info.fillLevel = objectTable.FillLvl;
			ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			if info.fillLevel <= 0.1 then inputEmty = true;end;
			if not outputFull then
				if not inputEmty then
					capacity = capacity+info.capacity;
					fillLevel = fillLevel+info.fillLevel;
				end;
			end;			
			info.container = container;					
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			inputFillTypes[container] = {};
			local fruitNames = "";
			local b = 1;		
			for acceptedFillTypes, v in pairs(objectTable.TipTrigger.acceptedFillTypes) do 			
				if v then
					local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, acceptedFillTypes, info.fillTypeName, nil);
					if not string.find(info.fillTypeName, fillTypeNameString) then info.lengthFillTypes = info.lengthFillTypes+1;end;
					info.fillTypeName = fillTypeNameString;					
				end;
				b = b+1			
			end;			
			table.insert(inputFillTypes[container], info);
			table.remove(info);			
		elseif otherType == "mixfeeder" and objectTable.mixFeeder ~= nil and objectTable.bunkerMixFeeder ~= nil then --MixFeeder
			local info={};			
			--objectTable.mixFeeder.type
			--objectTable.mixFeeder.noFatteningFeeder
			info.fillLevel = 0;
			info.capacity = -2;									
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("animals", nil, "Animals")).. ": ";
			if objectTable.type ~= nil then
				local animalType = objectTable.type;
				info.fillTypeName = info.fillTypeName.. tostring(moLanguageXml:getTxt(string.lower(animalType), nil, tostring(animalType)));
			end;
			if objectTable.noFatteningFeeder ~= nil then
				if not objectTable.noFatteningFeeder then
					info.fillTypeName = info.fillTypeName.. tostring(moLanguageXml:getTxt("a_mast", nil, "(mast)"));
				else
					info.fillTypeName = info.fillTypeName.. tostring(moLanguageXml:getTxt("a_breeding", nil, "(breeding)"));
				end;
			end;			
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};			
			local nextFillType = true;
			--if objectTable.feederBuyed ~= nil then
			--	if objectTable.feederBuyed then nextFillType = false;end;
			--end;
			if not nextFillType then
				info.extraText = tostring(moLanguageXml:getTxt("off", nil, "Off"));
				info.setColor = moGuiMiniPdaSlots.warningColor4;
				table.insert(outputFillTypes[container], info);
				container = container+1;
				table.remove(info);
			else
				setProduktivity = true;
				table.insert(outputFillTypes[container], info);
				info.setColor = moGuiMiniPdaSlots.warningColor1;
				container = container+1;
				table.remove(info);
				info={};			
				info.capacity = Utils.getNoNil(objectTable.mixFeeder.capacity, 0);	
				info.fillLevel = Utils.getNoNil(objectTable.mixFeeder.fillLevel, 0);
				ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
				if tonumber(ratio) >= 100 then outputFull = true;end;
				--if tonumber(productivity) >= tonumber(ratio) then
				--	productivity = tonumber(ratio);	
				--end;
				info.container = container;
				info.fillTypeName = "";
				info.lengthFillTypes = 1;					
				outputFillTypes[container] = {};
				local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, Fillable.FILLTYPE_FORAGE, info.fillTypeName, nil);					
				info.fillTypeName = fillTypeNameString;
				info.pricePerLiter = pricePerLiter;
				table.insert(outputFillTypes[container], info);
				table.remove(info);
				container = 1;				
				for k, v in pairs(objectTable.bunkerMixFeeder) do							
					info={};
					info.capacity = Utils.getNoNil(v.fillLevel, 0);
					info.fillLevel = Utils.getNoNil(v.fillLevel,0 );
					if info.fillLevel <= 0.1 then inputEmty = true;end;
					if v.capacityUse and not outputFull then
						if not inputEmpty then
							info.capacity = Utils.getNoNil(v.capacity, 0)
							capacity = capacity+info.capacity;
							fillLevel = fillLevel+info.fillLevel;
						end;
					end;
					info.container = container;					
					info.fillTypeName = tostring(moLanguageXml:getTxt("b_".. k, nil, tostring(g_i18n:getText("MixFeeder_"..k)))) --"";
					info.lengthFillTypes = 1;
					--local key = "FILLTYPE_"..string.upper(k);
					--local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, Fillable[key], info.fillTypeName, nil);
					inputFillTypes[container] = {};
					--info.fillTypeName = fillTypeNameString;
					info.pricePerLiter = 0;
					table.insert(inputFillTypes[container], info);
					container = container+1;
					table.remove(info);
				end;
			end;			
		end;
	elseif objectTable ~= nil and xmlModString ~= nil then
		local foundHeapsFillLevel = false;		
		local cancel = false;
		local acceptedFillTypes = {};
		if objectTable.acceptedFillTypes ~= nil then
			acceptedFillTypes = objectTable.acceptedFillTypes
		end;
		local info = {};
		info.fillTypeName = "";						
		info.pricePerLiter = 0;
		info.capacity = 0;
		info.fillLevel = 0;
		info.lengthFillTypes = 1;
		info.fillTypeContainerName = nil;
		for fillType,isAccepted in pairs(acceptedFillTypes) do				
			if cancel then break;end;
			if(isAccepted)then										
				info.fillLevel = objectTable:getFillLevel(fillType);						
				if info.fillLevel > 0.1 then cancel = true;foundHeapsFillLevel = true;info.fillTypeName = "";info.fillTypeContainerName = nil;end;
				local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, fillType, info.fillTypeName, nil);
				if info.fillTypeName ~= fillTypeNameString then info.lengthFillTypes = info.lengthFillTypes+1;info.fillTypeName = fillTypeNameString;end;
				info.fillTypeName = fillTypeNameString;
				info.pricePerLiter = pricePerLiter;				
			end;
		end;
		if not foundHeapsFillLevel then
			info.fillTypeContainerName = tostring(moLanguageXml:getTxt("empty", nil, "--Empty--"));				
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);			
		else
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
		end;		
	end;
	if setProduktivity then		
		productivity = Utils.getNoNil(fillLevel/capacity*100, 0);
		if not outputFull and not inputEmty then
			if tonumber(productivity) <= 90 and tonumber(productivity) >= 75 then
				productivityColor = moGuiMiniPdaSlots.warningColor1;
			elseif tonumber(productivity) < 75 and tonumber(productivity) >= 50 then
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			elseif tonumber(productivity) < 50 and tonumber(productivity) >= 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor3;
			elseif tonumber(productivity) < 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			end;
		else
			if inputEmty then 
				productivity = 0;
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			else
				productivity = 50;
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			end;
		end;
		outputFillTypes[1][1].productivity = productivity;
		outputFillTypes[1][1].productivityColor = productivityColor;	
	end;
	return inputFillTypes, outputFillTypes	
end;

function moSetGetInputOutputOther:getFillTypeStringName(self, fillType, fillTypeNameString, fillTypeName)
	local pricePerLiter = 0;
	local stringName = fillTypeNameString;
	local desc = Fillable.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then								
		local bestPriceTemp = 1;		
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		pricePerLiter = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;		
		if not string.find(stringName, moFillTypes[desc.index].fruitName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. moFillTypes[desc.index].fruitName;									
			else
				stringName = moFillTypes[desc.index].fruitName;
			end;								
		end;
	elseif fillTypeName ~= nil then		
		if not string.find(stringName, fillTypeName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. fillTypeName;									
			else
				stringName = fillTypeName;
			end;								
		end;
	else
		if not string.find(stringName, tostring(moLanguageXml:getTxt("unknow"))) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. tostring(moLanguageXml:getTxt("unknow"));									
			else
				stringName = tostring(moLanguageXml:getTxt("unknow"));
			end;								
		end;	
	end;	
	return pricePerLiter, stringName
end;